#require 'pry-byebug'
require 'time'
require 'date'
require 'pp'

require 'jungle_path/query'
require 'jungle_path/controller'
require 'jungle_path/cache'

require_relative '../db/db'
require_relative '../schemas/schema'
require_relative 'base'
require_relative '../controllers/controller'

module Server
  class API < Server::Base
    get '/' do
      # default page:
      #if request.env['X_MOBILE_DEVICE']
      #  #{}"<html><head></head><body>This is mobile!</body></html>"
      #  send_file File.join(settings.public_folder, 'index_mobile.html')
      #else
        #send_file File.join(settings.public_folder, 'src/pages/app/app.html')
        #"you are here"
        send_file File.join(settings.public_folder, 'index.html')
      #end
    end

    get '/app' do
      #"<html><head></head><body>zzzIs this mobile? mobile: #{request.env['X_MOBILE_DEVICE']}</body></html>"
      #send_file File.join(settings.public_folder, 'src/pages/app/app.html')
      send_file File.join(settings.public_folder, 'lib/pages/app/app.html')
      #"admin #{settings.public_folder}"
    end

    get '/admin' do
      #"<html><head></head><body>zzzIs this mobile? mobile: #{request.env['X_MOBILE_DEVICE']}</body></html>"
      #send_file File.join(settings.public_folder, 'src/pages/app/app.html')
      send_file File.join(settings.public_folder, 'src/pages/app/app.html')
      #"admin #{settings.public_folder}"
    end

    get '/query' do
      send_file File.join(settings.public_folder, 'query/query.html')
      #file = File.join(settings.public_folder, 'query/query.html')
      #"query #{settings.public_folder}<br>file: #{file}"
    end

    get '/query/doc' do
      file = File.join(configatron.application.public_dir, 'query/documents/query_api_documentation.txt')
      send_file File.join(file)
    end

    get '/query/schema_tree' do
      #root = Gen.gen_node_tree(Schema::Base.models)
      template_file = File.join(jungle.application.public_dir, 'query/documents/schema_tree_template.txt')
      template = File.read(template_file)

      node_tree = current_auth.schema_node_tree
      #template_output = "#{template}\n\n#{root.to_str}"
      template_output = "#{template}\n\n#{node_tree.to_str}"

      #output_file = File.join(configatron.application.public_dir, 'query/documents/schema_tree.txt')
      #File.write(output_file, template_output)
      #send_file File.join(output_file)
      template_output
    end

    get '/db/version' do
      ds = db.base['select version from schema_info']
      handle_result(ds.all)
    end

    get '/cachetest/:key' do
      key = params[:key]
      value = JunglePath::Cache[key]
      handle_result({key: "#{key}", value: "#{value}"})
    end

    get '/cachetest/:key/:value' do
      key = params[:key]
      value = params[:value]
      JunglePath::Cache[key] = value
      handle_result({key: "#{key}", value: "#{value}"})
    end

		get '/current/identity' do
			handle_result({identity: current_identity})
		end

    get '/current/user' do
      handle_result({user: current_user, key: current_key, role: current_role, auth: {permissions: current_auth.permissions, restrictions: current_auth.restrictions, schema_filter: current_auth.schema_filter}} )
    end

    get '/current/user/auth' do
      message = {
        user_id: current_user.id,
        user_name: current_user.user_name,
        #key_id: current_key.id,
        #key_name: current_key.name,
        #key_value: current_key.key,
        key_id: current_user.id,
        key_name: current_user.user_name,
        key_value: current_user.user_name,
        roles: current_auth.roles,
        permissions: current_auth.permissions,
        restrictions: current_auth.restrictions,
        schema_filter: current_auth.schema_filter
      }
      handle_result message
    end

    post '/debug/params' do
      puts "/debug/params:"
      pp params
    end
  end
end

require_relative 'generated'
