require 'jungle_path/gen/db'
require 'jungle_path/gen/schema'
require_relative '../schemas/schema'
require_relative '../config/config' # contains all settings except sensitive data set to nil.

module ZCreateDb
	def self.run db_config=nil
		db_config = jungle.db unless db_config
		puts "db_config port/name/user_name/password: #{db_config.port}/#{db_config.name}/#{db_config.user_name}/#{db_config.password}."
		JunglePath::Gen::DB.reset!(db_config)
		JunglePath::Gen::Schema.create(Schema::Base.models_dependent_order, db_config)

		this_path = File.expand_path(File.dirname(__FILE__))
		migrations_path = File.join(this_path, 'db', 'migrations')
		JunglePath::Gen::Schema.set_version_to_latest(Schema::SchemaInfo, db_config, migrations_path)
	end
end

ZCreateDb.run if ARGV[0] == 'run'
