module JunglePath
	module Controller
		module Helpers
			module User
		    def initialize(current_identity, params, db, model_class)
		      super(current_identity, params, db, model_class)
		    end

		    def insert(include_secure_columns: false)
		      id = @params[:id]
		      user_name = @params[:user_name]
		      user = @db.select._model(@table_class.new({id: id})) if id
		      user = @db.select._model_by_any(@table_class.new({user_name: user_name})) if ((not user) and user_name)
		      if user #already exists?
						puts "user #{user.user_name} already exists."
		        user._consume_hash(@params) # overwrite current values with new values
		        @params = user.to_hash # put all in @params for update
		        update
		        user = @db.select._model(user)
		      else
						puts "super..."
		        super
		      end
		    end
		  end

			module Key
				def initialize(current_identity, params, db, model_class)
					super(current_identity, params, db, model_class)
				end

				def insert(include_secure_columns: false)
					id = @params[:id]
					key = @db.select._model(@table_class.new({id: id})) if id
					if key #exists already, do update.
						key._consume_hash(@params) # overwrite current values with new values
						@params = key.to_hash # put all in @params for update
						update
						key = @db.select._model(key) # return updated object from database.
					else
						super
					end
				end
			end
		end
	end
end
