module JunglePath
	require 'jungle_path/db_model/schema'

	module DBAccess
		module IO
			require 'jungle_path/db_access/io/init_db'

			class Schema
				include JunglePath::DBAccess::IO::InitDB

				def drop_table(table_class)
					JunglePath::DBModel::Schema.new(@db).drop_table table_class
				end

				def create_table(table_class)
					JunglePath::DBModel::Schema.new(@db).create_table table_class
				end

				def reset_table(table_class)
					drop_table(table_class)
					create_table(table_class)
				end
			end
		end
	end
end
