# db_model.rb
# db_model
# Create ruby classes (models) based on database table definitions.
# Schema class (using the Sequel gem) can generate database tables from your models.
#
# Example from gbwho app's schema.rb file:
#
#        require_relative '../lib/db_model'
#
#        module Schema
#          class User < DBModel::Table
#            define(
#              [:id, :primary_key],
#              [:user_name, :string, :unique, :not_null, :alternate_key],
#              [:hash, :string, :not_null, :secure, :calculated, :desc, "See password_hash.rb for details."],
#              [:name, :string, :not_null, :desc, "Your human name! :)"],
#              [:email, :string, :not_null],
#              [:audit])
#          end
#        end

require 'set'
#require_relative 'json_wrap'
require 'jungle_path/json'

module JunglePath
  module DBModel
    require 'jungle_path/db_model/string'
    require 'jungle_path/db_model/column'
    require 'jungle_path/db_model/table'
    require 'jungle_path/db_model/schema'
    require 'jungle_path/db_model/params'
  end
end
