require 'erb'
require 'jungle_path/db_model/table'

module JunglePath
	module DBModel
	  class Table
	    # Adds useful methods to Table class for use when generating API and Model code:

	    def self.template_new
	      "#{self.name}.new"
	    end

	    def self.template_pk_url
	      pk = self.primary_key_columns.keys.map {|key| "/:#{key}"}
	      pk.join
	    end

	    def self.template_model_name
	      "Model::#{self.name.split('::').last}"
	    end

	    def self.template_params_pk_hash
	      #{id: p[:id]}
	      array = []
	      self.primary_key_columns.keys.each do |key|
	        array << "#{key}: p[:#{key}]"
	      end
	      "{#{array.join(',')}}"
	    end
	  end
	end
end

module JunglePath
	module Gen
	  def self.api(app_root_path, tables, output_file='./api/generated.rb', name_space='Server', controller_name_space='Controller', class_name='API', base_class_name='Base', template_file=nil)
	    if template_file
	      template_file = ::File.expand_path(template_file, app_root_path)
	    else
	      template_file = ::File.expand_path('../api/template.erb', ::File.dirname(__FILE__))
	    end

	    # template uses name_space,controller_name_space, class_name and base_class_name vars:``
	    template = ERB.new(File.read(template_file))

	    output_file = ::File.expand_path(output_file, app_root_path)
	    result = template.result(binding)
	    #puts result
	    File.write(output_file, result)
	  end
	end
end
