module JunglePath
	module Gen
		module SchemaTree
			class MatchColumns
				attr_reader :is_nil
				def initialize columns
					@is_nil = false
					@hash = {}
					@regexes = []
					if columns
						if columns.class == Symbol
							@hash[columns] = true
						elsif columns.class == String
							@hash[columns.to_sym] = true
						elsif columns.class == Regexp
							@regexes << columns
						elsif columns.class == Array and columns.length > 0
							columns.each do |col|
								if col.class == Symbol
									@hash[col] = true
								elsif columns.class == String
									@hash[col.to_sym] = true
								elsif col.class == Regexp
									@regexes << col
								else
									throw "Invalid type for col array item: #{col.class}, value: #{col}."
								end
							end
						elsif columns.class == Array
							@is_nil = true
						else
							throw "Invalid type for columns parameter: #{columns.class}, value: #{columns}."
						end
					else
						@is_nil = true
					end
				end

				def matched? column_name
					return true if @is_nil
					return true if @hash[column_name.to_sym]
					@regexes.each do |regx|
						return true if regx =~ column_name.to_s
					end
					false
				end

				def to_s
					"is_nil: #{@is_nil}, hash: #{@hash}, regexes: #{@regexes}."
				end
			end
		end
	end
end
