module JunglePath
	module Gen
		module SchemaTree
			class Node
	      attr_accessor :name, :symbol, :child_table_name, :child_table_join_column_name, :parent_table_join_column_name, :nodes, :tables_hash

	      def initialize(name, symbol=nil, child_table_name=nil, child_table_join_column_name=nil, parent_table_join_column_name=nil)
	        @name = name
	        @symbol = symbol
	        @child_table_name = child_table_name
	        @child_table_join_column_name = child_table_join_column_name
	        @parent_table_join_column_name = parent_table_join_column_name
	        @nodes = {}
	      end

	      def str_name
	        return "#{name} #{symbol} #{child_table_name}.#{child_table_join_column_name.to_s[0..-4]}" if (child_table_join_column_name and (symbol == "<=" or symbol == "<-"))
	        return "#{name} #{symbol} #{child_table_name}" if symbol
	        "#{name}"
	      end

	      def to_str(level=0)
	        indent = "  " * level
	        result = ["#{indent}#{str_name}"]
	        nodes.each do |k, v|
	          if v.class == ::Array
	            v.each do |item|
	              result << item.to_str(level + 1)
	            end
	          else
	            result << v.to_str(level + 1)
	          end
	        end
	        result.join("\n")
	      end
	    end
		end
	end
end
