# query.rb
#require 'pry-byebug'
#require 'pp'
#use: binding.pry where you want a break point.
require 'set'

module JunglePath
  module Query
    class Entity
      attr_accessor :name, :alias_, :node, :parent, :symbol, :fields, :filter, :sort, :limit, :offset, :field_node, :join_field_override, :parameters
      attr_reader :left_join
      def initialize(token, alias_, node, parent, symbol)
        @name = Entity.get_name_from_token(token)
        if token[-1] == "@"
          @left_join = true
        else
          @left_join = false
        end
        if token.include? '.'
          @join_field_override = token.split('.')[1]
          if @join_field_override[-1] == '@'
            @join_field_override = @join_field_override[0..-2]
          end
        else
          @join_field_override = nil
        end

        @alias_ = alias_
        @node = node
        @parent = parent
        @symbol = symbol
        @fields = nil
        @filter = nil
        @sort = nil
        @limit = nil
        @offset = nil
        @field_node = nil #If this entity object is created from within the field list put the field's node here.
      end

      def is_entity?
        true
      end

      def find_field(name)
        if fields
          fields.each do |field|
            if field.name == name
              return field
            end
          end
        end
        nil
      end

      def find_entity(name)
        field = find_field(name)
        if field
          return field
        end

        if fields
          fields.each do |f|
            if f.is_entity?
              field = f.find_entity(name)
              if field
                return f
                #return field
              end
            end
          end
        end
        field
      end

      def find_symbol
        symbol = node.symbol
        p = parent
        while true do
          if p.fields.count == p.fields_that_are_entities_count and p.parent
            symbol = p.node.symbol
            p = p.parent
          else
            break
          end
        end
        symbol
      end

      def find_parent_alias
        #binding.pry
        alias_ = nil
        p = parent
        while p and p.fields.count == p.fields_that_are_entities_count do
          p = p.parent
        end
        alias_ = p.alias_ if p
        alias_ = alias_.to_sym if alias_
        alias_
      end

      def fields_that_are_entities_count
        count = 0
        fields.each do |field|
          if field.is_entity?
            count += 1
          end
        end
        count
      end

      def self.get_name_from_token(token)
        if token[-1] == "@"
          token = token[0..-2]
        end
        if token.include? '.'
          token = token.split('.')[0]
        end
        token = token.downcase.to_sym
      end

      def self.select_node_from_array_by_token(nodes, token)
        # find closest matching node.
        # see gen_node_tree.rb lines 60+...
        node = nodes[0] # default
        if token.include? '.'
          name = token.split('.')[1]
          if name[-1] == '@'
            name = name[0..-2]
          end
          nodes.each do |n|
            if n.child_table_join_column_name.to_s.start_with?(name)
              node = n #found match
              break
            end
          end
        end
        node #return node.
      end
    end
  end
end
