# query.rb
#require 'pry-byebug'
#require 'pp'
#use: binding.pry where you want a break point.
require 'set'

module JunglePath
  module Query
    class Filter
      attr_reader :table_name, :pk_filter_query, :not_in
      def initialize table_name, pk_filter_query, not_in=false
        @table_name = table_name.to_sym
        @pk_filter_query = pk_filter_query
        @not_in = not_in
      end

      def fk_in_query table_alias, fk_column_name
        if @not_in
          "#{table_alias}.#{fk_column_name} not in (#{@pk_filter_query})"
        else
          "#{table_alias}.#{fk_column_name} in (#{@pk_filter_query})"
        end
      end

      def to_hash
        {table_name: @table_name, pk_filter_query: @pk_filter_query, not_in: @not_in}
      end

      def to_h
        to_hash
      end
    end
  end
end
