require 'jungle_path/sql/helpers'

module JunglePath
	module SQL
		module QueryFilter
			def self.by_user db, user
				sql = JunglePath::SQL::Helpers.sql("
					select
						a.id,
						a.name,
						a.base_table_name,
						a.sub_select
					from query_filter a
					join user_query_filter b on a.id = b.query_filter_id
					where b.user_id = ?
				")

				ds = db.base[sql, user.id]
				result = ds.all
				array = []
				result.each do |row|
					array << ({id: row[:id], name: row[:name], base_table_name: row[:base_table_name], sub_select: row[:sub_select]})
				end
				array
			end
		end
	end
end
