require 'jungle_path/sql/helpers'

module JunglePath
	module SQL
		module User
			def self.by_user_name(db, user_name)
				sql = JunglePath::SQL::Helpers.sql("
					#{base_sql}
					where a.user_name = ?
				")
				puts "sql:\n#{sql}."
				puts "user_name: #{user_name}."
				ds = db.base[sql, user_name]
				row = ds.first
				puts "row: #{row}."
				row
			end

			def self.by_key(db, key)
				sql = JunglePath::SQL::Helpers.sql("
					#{base_sql}
					join key b on a.id = b.user_id
					where b.key = ?
				")
				puts "sql:\n#{sql}."
				puts "key: #{key}."
				ds = db.base[sql, key]
				row = ds.first
				puts "row: #{row}."
				row
			end

			private

			def self.base_sql
				JunglePath::SQL::Helpers.sql("
					select
						a.id,
						a.user_name,
						a.hash,
						a.name,
						a.email,
						a.organization,
						a.notes,
						a.active,
						a.role,
						a.created_at,
						a.created_by_user_id,
						a.updated_at,
						a.updated_by_user_id
					from \"user\" a
				")
			end
		end
	end
end
