require 'jungle_path/sql/helpers'

module JunglePath
	module SQL
		module UserRole
	    def self.has_root_role_by_user_id(db, user_id)
	      puts "has_root_role_by_user_id: #{user_id}."
	      sql = JunglePath::SQL::Helpers.sql("
	        select
	          count(*)
	        from \"user\" a
	        join user_role b on b.user_id = a.id
	        join role c on c.id = b.role_id
	        where c.name = 'root'
	        and a.id = ?
	      ")
	      count = JunglePath::SQL::Helpers.get_count(db, sql, user_id)
	      puts "count: #{count}."
	      puts "(count > 0): #{(count > 0)}."
	      (count > 0)
	    end

	    def self.is_root_role_by_role_id(db, role_id)
	      puts "has_root_role_by_role_id: #{role_id}."
	      sql = JunglePath::SQL::Helpers.sql("
	        select
	          count(*)
	        from role a
	        where a.name = 'root'
	        and a.id = ?
	      ")
	      count = JunglePath::SQL::Helpers.get_count(db, sql, role_id)
	      puts "count: #{count}."
	      puts "(count > 0): #{(count > 0)}."
	      (count > 0)
	    end
	  end
	end
end
